#include "mpi.h"
#include <stdio.h>

int main(argc,argv) 
  int argc;
  char *argv[];  
{
  int numtasks, rank, dest, source, rc, count, sendtag, recvtag;  
  int sendmsg, recvmsg;
  MPI_Status Stat;
  
  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD, &numtasks);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  
  dest = (rank+1)%numtasks;
  source = (rank-1+numtasks)%numtasks;
  sendtag = rank;
  recvtag = source;
  sendmsg = rank + 10;

/*
  printf("dest=%d  source=%d  sendtag=%d  recvtag=%d\n",
          dest,source,sendtag,recvtag);
*/

  rc = MPI_Sendrecv(&sendmsg, 1, MPI_INT, dest, sendtag, &recvmsg, 1,
                    MPI_INT, source, recvtag, MPI_COMM_WORLD, &Stat);

  rc = MPI_Get_count(&Stat, MPI_INT, &count);
  printf("Task %d: Received %d int(s) from task %d with tag %d  msg=%d\n",
         rank, count, Stat.MPI_SOURCE, Stat.MPI_TAG, recvmsg);

  MPI_Finalize();
}
